Package com.io7m.waxmill.machines

# Class WXMDeviceVirtioNetwork

java.lang.Object
com.io7m.waxmill.machines.WXMDeviceVirtioNetwork

All Implemented Interfaces:
  `WXMDeviceType`, `WXMDeviceType.WXMDeviceNetworkType`, `WXMDeviceType.WXMDeviceVirtioNetworkType`

    public final class WXMDeviceVirtioNetwork
    extends java.lang.Object
    implements WXMDeviceType.WXMDeviceVirtioNetworkType

Immutable implementation of `WXMDeviceType.WXMDeviceVirtioNetworkType`.

Use the builder to create immutable instances: `WXMDeviceVirtioNetwork.builder()`.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type | Class | Description
  --- | --- | ---
  `static class` | `WXMDeviceVirtioNetwork.Builder` | Builds instances of type `WXMDeviceVirtioNetwork`.

  ## Nested classes/interfaces inherited from interface com.io7m.waxmill.machines.WXMDeviceType

  `WXMDeviceType.Kind, WXMDeviceType.WXMDeviceAHCIDiskType, WXMDeviceType.WXMDeviceAHCIOpticalDiskType, WXMDeviceType.WXMDeviceE1000Type, WXMDeviceType.WXMDeviceFramebufferType, WXMDeviceType.WXMDeviceHostBridgeType, WXMDeviceType.WXMDeviceLPCType, WXMDeviceType.WXMDeviceNetworkType, WXMDeviceType.WXMDevicePassthruType, WXMDeviceType.WXMDeviceVirtioBlockStorageType, WXMDeviceType.WXMDeviceVirtioNetworkType, WXMDeviceType.WXMLPCTTYNames, WXMDeviceType.WXMSectorSizesType, WXMDeviceType.WXMStorageBackendFileType, WXMDeviceType.WXMStorageBackendType, WXMDeviceType.WXMStorageBackendZFSVolumeType, WXMDeviceType.WXMTTYBackendFileType, WXMDeviceType.WXMTTYBackendNMDMType, WXMDeviceType.WXMTTYBackendStdioType, WXMDeviceType.WXMTTYBackendType`

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `WXMNetworkDeviceBackendType` | `backend()` |
  `static WXMDeviceVirtioNetwork.Builder` | `builder()` | Creates a builder for `WXMDeviceVirtioNetwork`.
  `java.lang.String` | `comment()` |
  `static WXMDeviceVirtioNetwork` | `copyOf​(WXMDeviceType.WXMDeviceVirtioNetworkType instance)` | Creates an immutable copy of a `WXMDeviceType.WXMDeviceVirtioNetworkType` value.
  `WXMDeviceSlot` | `deviceSlot()` |
  `boolean` | `equals​(java.lang.Object another)` | This instance is equal to all instances of `WXMDeviceVirtioNetwork` that have equal attribute values.
  `int` | `hashCode()` | Computes a hash code from attributes: `deviceSlot`, `comment`, `backend`.
  `java.lang.String` | `toString()` | Prints the immutable value `WXMDeviceVirtioNetwork` with attribute values.
  `WXMDeviceVirtioNetwork` | `withBackend​(WXMNetworkDeviceBackendType value)` | Copy the current immutable object by setting a value for the `backend` attribute.
  `WXMDeviceVirtioNetwork` | `withComment​(java.lang.String value)` | Copy the current immutable object by setting a value for the `comment` attribute.
  `WXMDeviceVirtioNetwork` | `withDeviceSlot​(WXMDeviceSlot value)` | Copy the current immutable object by setting a value for the `deviceSlot` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface com.io7m.waxmill.machines.WXMDeviceType

  `isConsoleDevice, isStorageDevice`

  ### Methods inherited from interface com.io7m.waxmill.machines.WXMDeviceType.WXMDeviceVirtioNetworkType

  `externalName, kind`

- ## Method Details

  - ### deviceSlot

    public WXMDeviceSlot deviceSlot()
    Specified by:
      `deviceSlot` in interface `WXMDeviceType`
    Specified by:
      `deviceSlot` in interface `WXMDeviceType.WXMDeviceNetworkType`
    Specified by:
      `deviceSlot` in interface `WXMDeviceType.WXMDeviceVirtioNetworkType`
    Returns:
      The value of the `deviceSlot` attribute

  - ### comment

    public java.lang.String comment()
    Specified by:
      `comment` in interface `WXMDeviceType`
    Specified by:
      `comment` in interface `WXMDeviceType.WXMDeviceNetworkType`
    Specified by:
      `comment` in interface `WXMDeviceType.WXMDeviceVirtioNetworkType`
    Returns:
      The value of the `comment` attribute

  - ### backend

    public WXMNetworkDeviceBackendType backend()
    Specified by:
      `backend` in interface `WXMDeviceType.WXMDeviceNetworkType`
    Specified by:
      `backend` in interface `WXMDeviceType.WXMDeviceVirtioNetworkType`
    Returns:
      The value of the `backend` attribute

  - ### withDeviceSlot

    public final WXMDeviceVirtioNetwork withDeviceSlot​(WXMDeviceSlot value)
    Copy the current immutable object by setting a value for the `deviceSlot` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for deviceSlot
    Returns:
      A modified copy of the `this` object

  - ### withComment

    public final WXMDeviceVirtioNetwork withComment​(java.lang.String value)
    Copy the current immutable object by setting a value for the `comment` attribute. An equals check used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for comment
    Returns:
      A modified copy of the `this` object

  - ### withBackend

    public final WXMDeviceVirtioNetwork withBackend​(WXMNetworkDeviceBackendType value)
    Copy the current immutable object by setting a value for the `backend` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for backend
    Returns:
      A modified copy of the `this` object

  - ### equals

    public boolean equals​(java.lang.Object another)
    This instance is equal to all instances of `WXMDeviceVirtioNetwork` that have equal attribute values.
    Overrides:
      `equals` in class `java.lang.Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `deviceSlot`, `comment`, `backend`.
    Overrides:
      `hashCode` in class `java.lang.Object`
    Returns:
      hashCode value

  - ### toString

    public java.lang.String toString()
    Prints the immutable value `WXMDeviceVirtioNetwork` with attribute values.
    Overrides:
      `toString` in class `java.lang.Object`
    Returns:
      A string representation of the value

  - ### copyOf

    public static WXMDeviceVirtioNetwork copyOf​(WXMDeviceType.WXMDeviceVirtioNetworkType instance)
    Creates an immutable copy of a `WXMDeviceType.WXMDeviceVirtioNetworkType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable WXMDeviceVirtioNetwork instance

  - ### builder

    public static WXMDeviceVirtioNetwork.Builder builder()
    Creates a builder for `WXMDeviceVirtioNetwork`.

         WXMDeviceVirtioNetwork.builder()
            .setDeviceSlot(com.io7m.waxmill.machines.WXMDeviceSlot) // required deviceSlot
            .setComment(String) // optional comment
            .setBackend(com.io7m.waxmill.machines.WXMNetworkDeviceBackendType) // required backend
            .build();

    Returns:
      A new WXMDeviceVirtioNetwork builder